<script>

// searchable dropdowm
import Multiselect from "vue-multiselect";
// searchable dropdowm

import pagination from "laravel-vue-pagination";
import { error_message, success_message } from "../../Helper/helper";
import { clientService } from "../../services";

/**
 * Customers component
 */
export default {
  components: {
    pagination,
    Multiselect,
  },
  data() {
    return {
      isLoading: false,
      vendor: [],
      selectedVendor: "",
      selectVendor: "",
      qrCode: "",
      feedbackCode: "",
      qrCodeView: false,
      feedbackCodeView: false,
      selectedResources: [],
      logo: "../../../../images/sales_channels/Martz90-Circle-Qr-code.512.png",
    };
  },
  methods: {
    getClient() {
      clientService.getAllClientList({}).then((response) => {        
        this.vendor = response.data.result;
        if (response.data.result[0] != "") {
          this.selectVendor = this.base64(response.data.result[0].id);
          this.selectedVendor = response.data.result[0];
          this.getQrCode(this.selectVendor);
        }
      });
    },

    base64(id) {
      return btoa(id);
    },

    getQrCode(dec_restaurant_id = "") {
      if (dec_restaurant_id != "") {
        clientService.getQrCode({ id: dec_restaurant_id }).then((response) => {
          if (response.data.code == 200) {
            if (response.data.result.path != "") {
              this.qrCode = response.data.result.path;
              this.qrCodeView = true;
            }
            if (response.data.result.feedback != "") {
              this.feedbackCode = response.data.result.feedback;
              this.feedbackCodeView = true;
            }
          } else {
            this.qrCodeView = false;
            this.feedbackCodeView = false;
          }
        });
      }
    },
    updateSelected({ name, restaurant_id }) {
      // this.selectedVendor = name;
      // this.selectedVendor = name.slice(0,11)+'...';
      this.selectVendor = this.base64(restaurant_id);
      this.getQrCode(this.selectVendor);
    },
  },

  mounted() {    
    this.getClient();
    $("body").click(function () {
      $(".multiselect__content-wrapper").css("display", "none");
    });
  },
};
</script>
<template>
  <div>  
    <b-container class="bv-example-row p-0">
      <b-row class="text-center">
        <b-col cols="12" class="p-0">
          <b-col cols="12">
            <div class="card">
              <div class="card-body">
                <b-container fluid>
                  <b-row class="text-left">
                    <div cols="12">
                      <h5 class="mt-4 left_txt">
                        <b-avatar variant="info" :src="logo" class="custom_avt"></b-avatar> {{trans.get('__JSON__.QrCode')}}
                      </h5>
                    </div>
                  </b-row>
                  <h5 class="mt-4 text-left">{{trans.get('__JSON__.Step 1')}}</h5>
                  <p class="text-left mb-3">
                    {{trans.get('__JSON__.You can generate QR Code for Each Vendors/Outlets')}}.
                  </p>
                  <p class="text-left">
                    {{trans.get('__JSON__.Lorem Ipsum is simply dummy text of the printing and typesetting industry. Lorem Ipsum has been the industry`s standard dummy text ever since the 1500s, when an unknown printer took a galley of type and scrambled it to make a type specimen book')}}
                  </p>
                </b-container>
                <!-- image display -->
                <b-container fluid class="mt-3">
                  <b-row>
                    <b-col cols="4" class="mt-0">
                      <multiselect                        
                        v-model="selectedVendor"
                        id="ajax"
                        label="name"
                        track-by="name"
                        :placeholder="trans.trans('__JSON__.Vendor Search', {vendor: $auth.setting.restaurant_name})"
                        open-direction="bottom"
                        :options="vendor"
                        :searchable="true"
                        :loading="isLoading"
                        selectLabel=""
                        @input="updateSelected"
                        :hide-selected="true" 
                        :max-height="600"
                      >
                      </multiselect>
                    </b-col>
                    <b-col cols="4" v-if="qrCodeView" class="mt-0">
                      <h5 class="text-center mb-4">{{trans.get('__JSON__.QR Code for Digital Manu')}}</h5>
                      <img :src="qrCode" class="mt-4 w-75" /><br />
                      <a class="mt-4 mb-3 btn btn-primary w-50" :href="qrCode" download >{{ trans.get("__JSON__.Download") }}</a>
                    </b-col>
                    <b-col cols="4" v-if="feedbackCodeView" class="mt-0">
                      <h5 class="text-center mb-4">{{trans.get('__JSON__.QR Code for Customer Dine-in Feedback')}}.</h5>
                      <img :src="feedbackCode" class="mt-1 w-75" /><br />
                      <a class="mt-4 mb-3 btn btn-primary w-50" :href="feedbackCode" download >{{ trans.get("__JSON__.Download") }}</a>
                    </b-col>
                  </b-row>
                </b-container>
                <!-- image display -->
              </div>
            </div>
          </b-col>
        </b-col>
      </b-row>
    </b-container>
  </div>
</template>   
<style>
.custom_avt{
    width: 26px!important;
    height: 25px!important;
}
.left_txt{
  margin-left: 10px;
}
.multiselect__select:before{
  z-index: 9;
}
</style>